package tareas.tarea2.electronica;

import java.awt.Graphics2D;
import java.awt.Point;
import tareas.tarea1.Forma;

/**
 * Clase heredada de Forma que implementa los metodos extra necesitados para la
 * implementacion de un componente electrico en un dibujo.
 * @author Klaus
 */
public abstract class Componente extends Forma {

    /** Rota la forma respecto a su centro en 90 grados.
     */
    public abstract void rotar();

    /** Dibuja la Forma en el Graphics2D.
     * @param g2d Grafico en el cual se incluira el dibujo.
     */
    public abstract void paintComponent(Graphics2D g2d);

    /**
     * Verifica si un punto esta dentro de el area seleccionable de la forma.
     * @param p Punto a verificar.
     * @return Verdadero si el punto esta dentro del area.
     */
    public abstract boolean isSelected(Point p);

    /** Retorna los nodos relacionados a este Componente.
     * @return Arreglo de nodos.
     */
    public abstract Nodo[] getNodos();

    /** Retorna el punto que basta para localizar la coordenada de un
     * componente, no asi su orientacion.
     * @return Punto con las coordenadas del componente.
     */
    public abstract Point getPunto();

    /** Redefine el metodo clone.
     * @return Un Objeto clon de este.
     */
    public abstract Object clone();
}
